//
//  LoginView.m
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/22.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import "AddPlayView.h"
#import "UserPlayAuthHeader.h"
@interface AddPlayView(){
    int mPlayType;
}
@end
@implementation AddPlayView
- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        UIControl *control = [[UIControl alloc]initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height)];
        [control addTarget:self action:@selector(hidekeybroad:) forControlEvents:UIControlEventTouchDown];
        [self addSubview:control];
        
        UILabel *appKeyLabel = [[UILabel alloc] init];
        [appKeyLabel setFrame:CGRectMake(10, 40, 120, 30)];
        [appKeyLabel setText:[NSString stringWithFormat:@"%@: ",NSLocalizedString(@"vid", nil)]];
        [appKeyLabel setTextColor:[UIColor blackColor]];
        [self addSubview:appKeyLabel];
        
        _textVid = [[UITextField alloc] init];
        [_textVid setFrame:CGRectMake(100, 35, 180, 30)];
        _textVid.placeholder = NSLocalizedString(@"the vid fill in the text field by user or default setting", nil);
        [_textVid setText:VID];
        _textVid.font = [UIFont systemFontOfSize:12.0f];
        [_textVid setTextColor:[UIColor blackColor]];
        [_textVid setBorderStyle:UITextBorderStyleRoundedRect];
        [self addSubview:_textVid];
        
        UILabel *appSecretLabel = [[UILabel alloc] init];
        [appSecretLabel setFrame:CGRectMake(10, 77, 120, 30)];
        [appSecretLabel setText:[NSString stringWithFormat:@"%@: ",NSLocalizedString(@"playAuth", nil)]];
        [appSecretLabel setTextColor:[UIColor blackColor]];
        [self addSubview:appSecretLabel];
        
        _textView = [[UITextView alloc] init];
        _textView.frame = CGRectMake(10, 110, self.frame.size.width-20, 90);
        _textView.textColor = [UIColor blackColor];
        _textView.backgroundColor = [UIColor whiteColor];
        _textView.font = [UIFont systemFontOfSize:12.0f];
        _textView.textAlignment = NSTextAlignmentLeft;
        _textView.textContainerInset = UIEdgeInsetsMake(20, 20, 20, 20);
        _textView.layer.cornerRadius = 5;
        _textView.layer.masksToBounds = YES;
        _textView.text = PLAY_AUTH;
        [self addSubview:_textView];
        
        _backBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
        _backBtn.frame = CGRectMake(40, 325, 100, 40);
        [_backBtn addTarget:self action:@selector(cancelBtnAction:) forControlEvents:(UIControlEventTouchUpInside)];
        [_backBtn setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
        [_backBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
        [_backBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
        [_backBtn setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
        [_backBtn setTitle:NSLocalizedString(@"cancel_button", nil) forState:UIControlStateNormal];
        _backBtn.clipsToBounds = YES;
        _backBtn.layer.cornerRadius = 20;
        [_backBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [self addSubview:_backBtn];
        
        _okBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
        _okBtn.frame = CGRectMake(160, 325, 100, 40);
        [_okBtn addTarget:self action:@selector(okBtnAction:) forControlEvents:(UIControlEventTouchUpInside)];
        [_okBtn setTitleColor:[UIColor colorWithRed:123 / 255.0 green:134 / 255.0 blue:252 / 255.0 alpha:1] forState:(UIControlStateNormal)];
        [_okBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
        [_okBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
        [_okBtn setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
        [_okBtn setTitle:NSLocalizedString(@"ok_button1", nil) forState:UIControlStateNormal];
        _okBtn.clipsToBounds = YES;
        _okBtn.layer.cornerRadius = 20;
        [_okBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [self addSubview:_okBtn];
        
        self.backgroundColor = [UIColor lightGrayColor];
        self.layer.cornerRadius = 8;
        self.layer.masksToBounds = YES;
        self.layer.borderWidth = 1;
        
        mPlayType = 0;
        self.delegate = nil;
    }
    
    return self;
}

-(void)hidekeybroad:(UIControl *)control{
    [_textVid resignFirstResponder];
    [_textView resignFirstResponder];
}

- (void)cancelBtnAction:(UIButton *)sender {
    self.hidden = YES;
}

- (void)okBtnAction:(UIButton *)sender {
    if (self.delegate && [self.delegate respondsToSelector:@selector(onClickAddPlay:vid:playAuth:)]) {
        [self.delegate onClickAddPlay:mPlayType vid:self.textVid.text playAuth:self.textView.text];
    }
    self.hidden = YES;
}

-(void)setAddPlayType:(int)Type{
    mPlayType = Type;
}

@end
