//
//  AliyunPlayerMediaDownloadsViewController.m
//  AliyunPlayerMediaDemo
//
//  Created by 王凯 on 2017/8/22.
//  Copyright © 2017年 com.alibaba.ALPlayerVodSDK. All rights reserved.
//

#import "AliyunPlayerMediaDownloadsViewController.h"
#import "AliyunDownloadTableViewCell.h"
#import <AliyunVodPlayerSDK/AliyunVodDownLoadManager.h>
#import "AliyunDownLoadAddView.h"

#import <AliyunVodPlayerSDK/AliyunVodPlayerSDK.h>
#import <AliyunVodPlayerViewSDK/AliyunVodPlayerViewSDK.h>

@interface AliyunPlayerMediaDownloadsViewController ()<UITableViewDelegate,UITableViewDataSource,AliyunDownloadTableViewCellDelegate,AliyunVodDownLoadDelegate>
    
@property(nonatomic, strong )UITableView *tableView;

@property(nonatomic, strong)NSMutableArray *downLists;

@property (nonatomic, strong)AliyunDownLoadAddView *addView;

@property (nonatomic, strong) NSMutableArray *listDataArray;
@property (nonatomic, strong) NSMutableArray *listAddArray;


@end

@implementation AliyunPlayerMediaDownloadsViewController

-(NSArray *)downLists
{
    if (!_downLists) {
        _downLists = [NSMutableArray array];
    }
    return _downLists;
}
    
-(UITableView *)tableView
{
    if (!_tableView) {
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height) style:UITableViewStylePlain];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.scrollEnabled = NO;
        UIView *footview = [[UIView alloc] initWithFrame:CGRectZero];
        _tableView.tableFooterView = footview;
        
    }
    return  _tableView;
}

- (AliyunDownLoadAddView*)addView{
    if (!_addView) {
        _addView = [[AliyunDownLoadAddView alloc] initWithFrame:self.view.bounds];
        _addView.hidden = YES;
    }
    return _addView;
}

- (void)initView{
        
    [self.view addSubview:self.tableView];
    [self.view addSubview:self.addView];
    [self.view bringSubviewToFront:self.addView];
    
}
#pragma mark - naviBar
- (void)naviBar{
        self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"返回" style:UIBarButtonItemStylePlain target:self action:@selector(leftBarButtonItemCliceked:)];
        self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"添加下载" style:UIBarButtonItemStylePlain target:self action:@selector(rightBarButtonItemCliceked:)];
}
    
- (void)leftBarButtonItemCliceked:(UIBarButtonItem*)sender{
    
    [self.navigationController popViewControllerAnimated:YES];
    
}

- (void)rightBarButtonItemCliceked : (UIBarButtonItem *)sender{

    self.addView.hidden = NO;
}
    
- (void)viewDidLoad {

    [super viewDidLoad];
    
    self.edgesForExtendedLayout = UIRectEdgeNone;
    self.view.backgroundColor = [UIColor whiteColor];
    [self naviBar];
    [self initView];
    
/***************************************************************************/
    self.listDataArray = [NSMutableArray array];
    self.listAddArray = [NSMutableArray array];
    
    ///下载必须要设置的三个内容：1.下载代理 2.下载路径3.下载加密的秘钥（如果要加密的话）
    //设置下载代理
    [[AliyunVodDownLoadManager shareManager] setDownloadDelegate:self];
    
    //设置下载路径
    NSString *path = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES)[0];
    [[AliyunVodDownLoadManager shareManager] setDownLoadPath:path];
    
    //设置下载加密秘钥
    NSString* appInfo = [[NSString alloc] initWithFormat:@"%@/encryptedApp.dat",path];
    NSString* appInfoNew = [[NSString alloc] initWithFormat:@"%@/encryptedApp1.dat",path];
    
    [[AliyunVodDownLoadManager shareManager] setEncrptyFile:appInfo];
    
    
    NSArray* array = [[AliyunVodDownLoadManager shareManager] allMedias];
    
    //    NSString* file = [[NSString alloc] initWithFormat:@"%@/9e1ef889a8624d5e97a5374b5f2cdec1_m3u8_0.mp4",path];
    //    NSMutableArray* array = [[NSMutableArray alloc] init];
    //    [array addObject:file];
    //
    //    NSString* file1 = [[NSString alloc] initWithFormat:@"%@/9e1ef889a8624d5e97a5374b5f2cdec1_m3u8_1.mp4",path];
    //    [array addObject:file1];
    //
    //    [[AliyunVodDownLoadManager shareManager] changeEncryptFile:appInfo newEncryptFile:appInfoNew mp4Files:array];
    
    //设置同时下载的个数
    [[AliyunVodDownLoadManager shareManager] setMaxDownloadOperationCount:4];
    
    
    
    // Do any additional setup after loading the view.
}

#pragma mark - tableDelegate/datasource
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}
    
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return  4;
}
    
    
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *cellIdentifier = @"democell";
    AliyunDownloadTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (!cell) {
        cell = [[[NSBundle mainBundle] loadNibNamed:@"AliyunDownloadTableViewCell" owner:nil options:nil] firstObject];
    }
    cell.cellDelegate = self;
    
    return cell;
    
}
    
- (void)aliyunDownloadCell:(AliyunDownloadTableViewCell *)cell onClickedButton:(UIButton *)button
{
    
    NSIndexPath *indexPath = [self.tableView indexPathForCell:cell];
    NSLog(@"indexPath is = %i",indexPath.row);
    
    
    
    switch (button.tag) {
        case 101:
            [cell setDownloadStateString:@"loading"];
        break;
        case 102:
            [cell setDownloadStateString:@"stop"];
        break;
        case 103:
            [cell setDownloadStateString:@"del"];
        break;
        case 104:
            [cell setDownloadStateString:@"play"];
        break;
        
        default:
        break;
    }
}
    

#pragma mark - downLoadDelegate
/*
 功能：未完成回调，异常中断导致下载未完成，下次启动后会接收到此回调。
 回调数据：AliyunDownloadMediaInfo数组
 */
-(void) onUnFinished:(NSArray<AliyunDataSource*>*)mediaInfos{


}


/*
 功能：获取playAuth凭证。
 */
-(NSString*) onGetPlayAuth:(NSString*)vid format:(NSString*)format quality:(AliyunVodPlayerVideoQuality)quality{

    NSString *playAuth = @"";
    
    return playAuth;
}

/*
 功能：准备下载回调。
 回调数据：AliyunDownloadMediaInfo数组
 */
-(void) onPrepare:(NSArray<AliyunDownloadMediaInfo*>*)mediaInfos{

}

/*
 功能：下载开始回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onStart:(AliyunDownloadMediaInfo*)mediaInfo{

}

/*
 功能：下载进度回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onProgress:(AliyunDownloadMediaInfo*)mediaInfo{


}

/*
 功能：下载结束回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onStop:(AliyunDownloadMediaInfo*)mediaInfo{


}

/*
 功能：下载开始回调。
 回调数据：AliyunDownloadMediaInfo
 */
-(void) onCompletion:(AliyunDownloadMediaInfo*)mediaInfo{


}

/*
 功能：改变加密图，重新加密之前视频文件进度。
 回调数据：progress进度
 */
-(void) onChangeEncryptFileProgress:(int)progress{

}

/*
 功能：改变加密图回调。
 */
-(void) onChangeEncryptFileComplete{


}

/*
 功能：下载结束回调。错误码与错误信息见下表
 回调数据：AliyunDownloadMediaInfo， code：错误码 msg：错误信息
 */
-(void)onError:(AliyunDownloadMediaInfo*)mediaInfo code:(int)code msg:(NSString *)msg{



}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
