//
//  ViewController.m
//  AliyunPlayerMediaDemo
//
//  Created by 王凯 on 2017/8/14.
//  Copyright © 2017年 com.alibaba.ALPlayerVodSDK. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"
#import "AddPlayView.h"
#import "AliyunPlaySDKDemoOneViewController.h"
#import "AliyunPlaySDKListsAutoViewController.h"
#import "AliyunPlaySDKDemoFullScreenScrollViewController.h"
#import "AliyunPlayerMediaDownloadsViewController.h"
#import "DownloadViewController.h"
#import "ALiyunPlaySDKCheckToolViewController.h"
#import "AliyunPlayerMediaUIDemoViewController.h"

#define SCREEN_WIDTH [UIScreen mainScreen].bounds.size.width
#define SCREEN_HEIGHT [UIScreen mainScreen].bounds.size.height

@interface ViewController ()<UITableViewDelegate,UITableViewDataSource,addPlayDelegate>

@property(nonatomic, strong )UITableView *tableView;
@property(nonatomic, strong)NSArray *titlesAry;
@property(nonatomic, strong)AddPlayView *mAddView;

@end

@implementation ViewController

-(NSArray *)titlesAry{
    if (!_titlesAry) {
        _titlesAry = @[NSLocalizedString(@"Basic function demo of Vod by using vid and palyAuth", nil),
                       NSLocalizedString(@"Autoplay demo of multi-video by using url", nil),
                       NSLocalizedString(@"Full screen slide play demo by using url", nil),
                       NSLocalizedString(@"Breakpoints download demo", nil),
                       NSLocalizedString(@"Full UI player demo", nil),
                       ];
    }
    return _titlesAry;
}

-(UITableView *)tableView{
    if (!_tableView) {
        _tableView = [[UITableView alloc]initWithFrame:CGRectZero style:UITableViewStylePlain];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.scrollEnabled = NO;
        UIView *footview = [[UIView alloc] initWithFrame:CGRectZero];
        _tableView.tableFooterView = footview;
    }
    return  _tableView;
}

-(AddPlayView *)mAddView{
    if (!_mAddView) {
        _mAddView = [[AddPlayView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH-300)/2, 44, 300, 400)];
        _mAddView.hidden = YES;
        _mAddView.delegate = self;
    }
    return _mAddView;
}

- (void)initView{
    [self.view addSubview:self.tableView];
    [self.view addSubview:self.mAddView];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title =  NSLocalizedString(@"Scene List of player", nil);
    self.edgesForExtendedLayout = UIRectEdgeNone;
    [self initView];
    // Do any additional setup after loading the view, typically from a nib.
}


-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden  = NO;
}

-(void)viewWillLayoutSubviews{
    [super viewWillLayoutSubviews];
    self.tableView.frame = CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height);
    self.mAddView.frame = CGRectMake((SCREEN_WIDTH-300)/2, 44, 300, 400);
}

#pragma mark - tableDelegate/datasource
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return  self.titlesAry.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *cellIdentifier = @"democell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];\
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier];
    }
    cell.textLabel.text = self.titlesAry[indexPath.row];
    cell.textLabel.font = [UIFont systemFontOfSize:15.0f];
    cell.accessoryType=UITableViewCellAccessoryDisclosureIndicator;
    return cell;
}


-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(nonnull NSIndexPath *)indexPath{
    switch (indexPath.row) {
        case 0:
        {
            /*********点播播放功能(vid+playAuth方式演示)**********/
            self.mAddView.hidden = NO;
            [self.mAddView setAddPlayType:0];
        }
            break;
        case 1:
        {
            /*********多视频列表自动播放(url方式演示)**********/
            AliyunPlaySDKListsAutoViewController *demoTwo = [[AliyunPlaySDKListsAutoViewController alloc]     init];
            demoTwo.title = self.titlesAry[indexPath.row];
            [self.navigationController pushViewController:demoTwo animated:YES];
            
        }
            break;
        case 2:
        {
            /*********全屏滑动切换播放(url方式演示)***********/
            AliyunPlaySDKDemoFullScreenScrollViewController *demoThree = [[AliyunPlaySDKDemoFullScreenScrollViewController alloc] init];
            demoThree.title = self.titlesAry[indexPath.row];
            [self.navigationController pushViewController:demoThree animated:YES];
        }
            break;
        case 3 :
        {
            /*********多视频断点下载演示*********************/
            DownloadViewController *demoFour =  [DownloadViewController sharedViewController];
            demoFour.title = self.titlesAry[indexPath.row];
            [self.navigationController pushViewController:demoFour animated:YES];
            
        }
            break;
        case 4:
        {
            /*********完整UI播放器基本功能演示***************/
            self.mAddView.hidden = NO;
            [self.mAddView setAddPlayType:1];
        }
            break;
        default:
            break;
    }
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

-(void)onClickAddPlay:(int)clickType vid:(NSString *)vid playAuth:(NSString *)playAuth{
    //无UI
    if (clickType == 0) {
        AliyunPlaySDKDemoOneViewController *demoOne = [self.storyboard instantiateViewControllerWithIdentifier:@"AliyunPlaySDKDemoOneViewController"];
        demoOne.videoId = vid;
        demoOne.playAuth = playAuth;
        demoOne.title = self.titlesAry[0];
        [self.navigationController pushViewController:demoOne animated:YES];
    }
    else if(clickType == 1){
        AliyunPlayerMediaUIDemoViewController *demoFive = [[AliyunPlayerMediaUIDemoViewController alloc] init];
        demoFive.videoId = vid;
        demoFive.playAuth = playAuth;
        [self presentViewController:demoFive animated:YES completion:nil];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
